// #autoload
// #name = Engineers' HUD
// #version = 1.20
// #date = July 15, 2002
// #status = release
// #description = Displays tactical assets and their repair state. Toggles on and off via configurable key. May bring up arrow and select items via configurable key.
// #author = |TIA|Prometheus
// #warrior = Prometheus^
// #email = rrk@u.arizona.edu
// #web = http://www.tribe-tia.com
// #config = EngHUDOptions
// #credit = Special thanks to |TIA|Quarmal and |TIA|Comatoast for inspiring the idea, excellent beta testing, and  constructive feedback.
// #include = scripts/autoexec/TeamInfo.cs
// #readme = scripts/EngineersHUDmodified.txt
//
//  TeamInfo.cs is REQUIRED for this script to work
//------------------------------------------------------------------------------------------------------------------

if (!isObject(EngHUD)) new GuiControl(EngHUD)
{
	profile = "NewScrollCtrlProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "150 458";
	minExtent = "12 16";
};

if (!isObject(EngHUDOptions)) new GuiControl(EngHUDOptions)
{
	profile = "GuiDefaultProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 10";
	extent = "400 310";
	minExtent = "8 8";
	visible = "1";
	helpTag = "0";

	new ShellToggleButton()	{
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "10 6";
		extent = "180 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$pref::EngHUD::on";
		command = "EHReset();";
		helpTag = "0";
		text = "ENGINEERS\' HUD ENABLED";
		maxLength = "255";
	};

	new ShellToggleButton() {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "28 40";
		extent = "140 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$pref::EngHUD::ShowTeammates";
		command = "EHReset();";
		helpTag = "0";
		text = "Show Teammates";
		maxLength = "255";
	};

	new ShellToggleButton() {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "28 70";
		extent = "140 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$pref::EngHUD::ShowTactical";
		command = "EHReset();";
		helpTag = "0";
		text = "Show Tactical Assets";
		maxLength = "255";
	};

	new ShellToggleButton() {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "28 100";
		extent = "140 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$pref::EngHUD::ShowSupport";
		command = "EHReset();";
		helpTag = "0";
		text = "Show Support Assets";
		maxLength = "255";
	};

	new ShellToggleButton() {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "28 130";
		extent = "140 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$pref::EngHUD::ShowDTactical";
		command = "EHReset();";
		helpTag = "0";
		text = "Show Deployed Tactical";
		maxLength = "255";
	};

	new ShellToggleButton() {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "28 160";
		extent = "140 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$pref::EngHUD::ShowDSupport";
		command = "EHReset();";
		helpTag = "0";
		text = "Show Deployed Support";
		maxLength = "255";
	};

	new ShellToggleButton() {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "28 200";
		extent = "140 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$pref::EngHUD::Transparent";
		command = "EHReset();";
		helpTag = "0";
		text = "Transparent Background";
		maxLength = "255";
	};

	new ShellToggleButton() {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "28 230";
		extent = "140 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$pref::EngHUD::Compact";
		command = "EHReset();";
		helpTag = "0";
		text = "Compact Style";
		maxLength = "255";
	};

	new ShellToggleButton() {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "28 260";
		extent = "140 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$pref::EngHUD::Narrow";
		command = "EHReset();";
		helpTag = "0";
		text = "Icons Only";
		maxLength = "255";
	};

    new GuiTextCtrl() {
        profile = "ShellTextProfile";
        horizSizing = "right";
        vertSizing = "bottom";
        position = "210 40";
        extent = "97 22";
        minExtent = "8 8";
        visible = "1";
        hideCursor = "0";
        bypassHideCursor = "0";
        helpTag = "0";
        text = "Maximum Height:";
        maxLength = "255";
    };

    new ShellSliderCtrl(EH_MaxExtent) {
        profile = "ShellSliderProfile";
        horizSizing = "right";
        vertSizing = "bottom";
        position = "210 58";
        extent = "170 24";
        minExtent = "12 24";
        visible = "1";
        hideCursor = "0";
        bypassHideCursor = "0";
        Command = "$pref::EngHUD::MaxExtent = mfloor(EH_MaxExtent.getValue());";
        helpTag = "0";
        range = "16 480";
        ticks = "465";
        value = "458";
        usePlusMinus = "1";
    };
    
    new GuiTextCtrl() {
        profile = "ShellTextProfile";
        horizSizing = "right";
        vertSizing = "bottom";
        position = "220 92";
        extent = "500 22";
        minExtent = "8 8";
        visible = "1";
        hideCursor = "0";
        bypassHideCursor = "0";
        helpTag = "0";
        text = "This script was modified to use with custom GUI: Move Chat HUD (Disabled)";
        maxLength = "255";
    };

    new GuiTextCtrl() {
        profile = "ShellTextProfile";
        horizSizing = "right";
        vertSizing = "bottom";
        position = "230 130";
        extent = "55 22";
        minExtent = "8 8";
        visible = "1";
        hideCursor = "0";
        bypassHideCursor = "0";
        helpTag = "0";
        text = "X Position:";
        maxLength = "255";
    };

	new ShellTextEditCtrl() {
	    profile = "NewTextEditProfile";
		horizSizing = "right";
		vertSizing = "bottom";
	    position = "280 122";
		extent = "64 38";
	    minExtent = "32 38";
		visible = "1";
	    hideCursor = "0";
		bypassHideCursor = "0";
	    variable = "$pref::EngHUD::PosX";
		helpTag = "0";
	    longTextBuffer = "0";
		maxLength = "255";
	    historySize = "0";
		password = "0";
	    tabComplete = "0";
		glowOffset = "9 9";
    };

    new GuiTextCtrl() {
        profile = "ShellTextProfile";
        horizSizing = "right";
        vertSizing = "bottom";
        position = "230 160";
        extent = "55 22";
        minExtent = "8 8";
        visible = "1";
        hideCursor = "0";
        bypassHideCursor = "0";
        helpTag = "0";
        text = "Y Position:";
        maxLength = "255";
    };

	new ShellTextEditCtrl() {
	    profile = "NewTextEditProfile";
		horizSizing = "right";
		vertSizing = "bottom";
	    position = "280 152";
		extent = "64 38";
	    minExtent = "32 38";
		visible = "1";
	    hideCursor = "0";
		bypassHideCursor = "0";
	    variable = "$pref::EngHUD::PosY";
		helpTag = "0";
	    longTextBuffer = "0";
		maxLength = "255";
	    historySize = "0";
		password = "0";
	    tabComplete = "0";
		glowOffset = "9 9";
    };
};

$CommandTask['Player', 3, text] = "\c1F\crind";
$CommandTask['Player', 3, tag] = 'FindPlayer';
$CommandTask['Player', 3, hotkey] = "f";
$CommandTask['Object', 6, text] = "\c1F\crind";
$CommandTask['Object', 6, tag] = 'FindObject';
$CommandTask['Object', 6, hotkey] = "f";

function toggleEngHUD()
{
	if ($EngHUD::toggledown)  // we only toggle on release of keypress
    {
        $pref::EngHUD::on = !$pref::EngHUD::on;
        EHReset();
    }
	$EngHUD::toggledown = !$EngHUD::toggledown;
}

function toggleCursor()
{
    if ($EngHUD::cursor == 3) $EngHUD::cursor=0;
    else $EngHUD::cursor++;
    if ($EngHUD::cursor < 2) cursorOff();
    else cursorOn();
}

function toggleMapHUD()
{
	if ($EngHUD::maptoggledown)  // we only toggle on release of keypress
    {
        $pref::EngHUD::MapOn = !$pref::EngHUD::MapOn;
        EHReset();
    }
	$EngHUD::maptoggledown = !$EngHUD::maptoggledown;
}

function EngHUD::StoreOpenCategories(%this)
{
    %this.PlayersOpen = CMDPlayersButton.getValue();
    %this.WaypointsOpen = CMDWaypointsButton.getValue();
    %this.ObjectivesOpen = CMDObjectivesButton.getValue();
    %this.TacticalOpen = CMDTacticalButton.getValue();
    %this.SupportOpen = CMDMiscButton.getValue();
    %this.DTacticalOpen = CMDDeployedTacticalButton.getValue();
    %this.DSupportOpen = CMDDeployedMiscButton.getValue();
}

function EngHUD::RestoreOpenCategories(%this)
{
    CommanderTree.openCategory("Clients",%this.PlayersOpen);  // restore these categories
    CommanderTree.openCategory("Waypoints",%this.WaypointsOpen);
    CommanderTree.openCategory("Objectives",%this.ObjectivesOpen);
    CommanderTree.openCategory("Tactical",%this.TacticalOpen);
    CommanderTree.openCategory("Support",%this.SupportOpen);
    CommanderTree.openCategory("DTactical",%this.DTacticalOpen);
    CommanderTree.openCategory("DSupport",%this.DSupportOpen);
}

function EngHUD::controlObject(%this,%target)
{
    commandToServer('ControlObject',%target);
    EHReset();
}

function EngHUD::Reset()
{
    EHReset();
}

function EHReset()
{
    $EngHUD::cursor=0;
    if (!$pref::EngHUD::on || !$MyTeamId || ($HudMode $= "PickTeam"))
	{
        commandToServer('ScopeCommanderMap', false);
		GuiGroup.add(EngHUD);
        CommanderMap.restore();
		MainChatHud.getObject(0).position = EngHUD.ChatPosition;  // restore ChatHUD's position
		return;
	}

    CommanderTree.position = "0 0";  // does not start here for some reason
    CommanderTree.headerHeight = 0;  // no headers
    CommanderTree.entryHeight = ($pref::EngHUD::Compact) ? 16 : 20;  // 20% smaller
    CommanderTree.backdropBitmapName = ($pref::EngHUD::Transparent) ?
        "special/whiteAlpha0" : "commander/gui/cmd_columnheadbar";  // transparent or translucent blue
    CommanderTree.entryHilightColor = "0 0 0 0";  // transparent
    CommanderTree.entrySelectColor = "0 0 0 0";

    CommanderTree.openCategory("Waypoints",0);  // close these categories, categorically :)
    CommanderTree.openCategory("Objectives",0);
    CommanderTree.openCategory("Clients",$pref::EngHUD::ShowTeammates);  // open preferred categories
    CommanderTree.openCategory("Tactical",$pref::EngHUD::ShowTactical);
    CommanderTree.openCategory("Support",$pref::EngHUD::ShowSupport);
    CommanderTree.openCategory("DTactical",$pref::EngHUD::ShowDTactical);
    CommanderTree.openCategory("DSupport",$pref::EngHUD::ShowDSupport);

    $pref::EngHUD::Width = $pref::EngHUD::Narrow ? 20 : 150;
    
    if ($pref::EngHUD::ShowTeammates) CommanderTree.position = "0 -"@ CommanderTree.entryHeight;
        // Kill the "none selected" entry line

    if ($pref::EngHUD::MapOn)  // show commander map
    {
        CommanderMap.extent = "150 150";
        if (($pref::EngHUD::PosX < 150) && ($pref::EngHUD::PosY < 150))
            EngHUD.position = $pref::EngHUD::PosX @" 150";  // push down EngHUD
        PlayGui.add(CommanderMap);
        CommanderMap.selectControlObject();
        CommanderMap.followLastSelected();
        if (!CommanderMap.zoomed)
        {
            CommanderMap.zoomVelocity = 100;
            CommanderMap.cameraMove(in,true);
            CommanderMap.schedule(500, "cameraMove", in, false);
            CommanderMap.zoomed = true;
        }
    }
    else
    {
        CommanderMap.restore();
        EngHUD.position = $pref::EngHUD::PosX SPC $pref::EngHUD::PosY;
    }

    EngHUD.extent = $pref::EngHUD::Width SPC $pref::EngHUD::MaxExtent;
    if (EngHUD.getGroup() != nameToId(PlayGui)) PlayGui.add(EngHUD);
    EngHUD.add(CommanderTree);  // add our HUD
    commandToServer('ScopeCommanderMap', true);
}

function EngHUDOptions::onWake(%this)
{
    %height = getword($pref::Video::resolution,1);
    EH_MaxExtent.range = "16 "@ %height;
    EH_MaxExtent.ticks = %height-15;
    EH_MaxExtent.setValue($pref::EngHUD::MaxExtent);
}

function CommanderMap::restore(%this)
{
    if (CommanderMap.getGroup() == nameToId(CommanderMapGui)) return;
    CommanderMapGui.add(%this);  // put map back
    %this.extent = getWord(CommanderTV.position,0) SPC getWord(CommanderMapGui.extent,1);
    CommanderMapGui.bringToFront(%this);
    %this.resetCamera();
    %this.zoomed = false;
    %this.zoomVelocity = 500;
}

//function CommanderMap::fixZoomVelocity(%this) { %this.zoomVelocity = 500; }

package EngineerHUD
{

function CommanderMapGui::open(%this)
{
	if (CommanderTree.getGroup() == nameToId(EngHUD))
    {
        // basically we want to undo all we did:
        CommanderTreeContainer.getObject(0).add(CommanderTree);  // put this back
        CommanderTree.position = "0 0";
        CommanderTree.headerHeight = 20;  // add headers
        CommanderTree.entryHeight = 20;  // restore height
        CommanderTree.backdropBitmapName = "commander/gui/cmd_gradient";
        CommanderTree.entryHilightColor = "44 168 219 100";
        CommanderTree.entrySelectColor = "255 0 0 100";
        EngHUD.RestoreOpenCategories();
    }
    CommanderMap.restore();
	parent::open(%this);
}

function CommanderMapGui::close(%this)
{
    EngHUD.StoreOpenCategories();  // cache these so they are resored when we reopen CmdMap
    EHReset();
    parent::close(%this);
}

function CommanderMap::openAllCategories(%this)
{
	parent::openAllCategories(%this);
	EngHUD.schedule(500,"StoreOpenCategories");
}

function CommanderTree::controlObject(%this, %targetId)
{
    if (!CommanderMapGui.open)
    {
        CommanderMapGui.open();
    }
    EngHUD.schedule(300,"controlObject",%targetId);
}

function clientCmdControlObjectReset()
{
    if ($PlayerIsControllingObject)
    {
        parent::clientCmdControlObjectReset();
        CommanderMapGui.toggle();
        CommanderMapGui.toggle();
    }
    else parent::clientCmdControlObjectReset();
}

function MessageHud::open(%this)
{
    parent::open(%this);
    if (!$pref::EngHUD::on) return;
    messageHud_Frame.position = setWord(messageHud_Frame.position,0,%margin);
}

function lobbyReturnToGame()
{
    parent::lobbyReturnToGame();
    EngHUD.schedule(100,"Reset");  // may be new resolution
}

function ClientCmdDisplayHuds()
{
    EngHUD.extent = $pref::EngHUD::Width SPC $pref::EngHUD::MaxExtent;
	parent::ClientCmdDisplayHuds();
    EHReset();
}

function clientCmdControlObjectResponse(%ack, %info)
{
    if (!%ack && (CommanderTree.getGroup() == nameToId(EngHUD)))  // could not control object
        CommanderMapGui.close();  // get back to playgui
    parent::clientCmdControlObjectResponse(%ack, %info);
}

function CommanderTree::processCommand(%this, %command, %target, %typeTag)
{
    $EngHUD::cursor=0;  // reset the cursor toggle state
    if (%command $= 'FindObject')
    {
        %target.sendToServer();
        commandToServer('AcceptTask', $MyClientId, -1, "Find the "@
            getTaggedString(CMContextPopup.nameTag) SPC getTaggedString(%typeTag));
    }
    else if (%command $= 'FindPlayer')
    {
        %target.sendToServer();
        commandToServer('AcceptTask', $MyClientId, -1, "Escort "@ getTaggedString(CMContextPopup.nameTag));
    }
    else parent::processCommand(%this, %command, %target, %typeTag);
}

function clientCmdTaskAccepted(%from, %description)
{
    if (rawName(%from) $= $PlayerName) return;
    parent::clientCmdTaskAccepted(%from, %description);
}

function OptionsDlg::applyGraphicChanges( %this )
{
    parent::applyGraphicChanges(%this);
    EngHUDOptions.onWake();
}

};

//------------------------------------------------------------------------------------------------------------------

addMessageCallback('MsgIJoinedTeam',EHReset);

if (!$EngHUD::OptionsLine)
{
	$EngHUD::OptionsLine = $RemapCount;
	$RemapName[$RemapCount]= "EngineerHUD";
	$RemapCmd[$RemapCount]= "toggleEngHUD";
	$RemapCount++;
	$RemapName[$RemapCount]= "Cursor on/off";
	$RemapCmd[$RemapCount]= "toggleCursor";
	$RemapCount++;
	$RemapName[$RemapCount]= "MapHUD toggle";
	$RemapCmd[$RemapCount]= "toggleMapHUD";
	$RemapCount++;
}

if ($pref::EngHUD::on $= "") $pref::EngHUD::on = true;  // defaults are here
if ($pref::EngHUD::ShowTeammates $= "") $pref::EngHUD::ShowTeammates = true;
if ($pref::EngHUD::ShowTactical $= "") $pref::EngHUD::ShowTactical = true;
if ($pref::EngHUD::ShowSupport $= "") $pref::EngHUD::ShowSupport = true;
if ($pref::EngHUD::ShowDTactical $= "") $pref::EngHUD::ShowDTactical = true;
if ($pref::EngHUD::ShowDSupport $= "") $pref::EngHUD::ShowDSupport = true;
if ($pref::EngHUD::Transparent $= "") $pref::EngHUD::Transparent = true;
if ($pref::EngHUD::Compact $= "") $pref::EngHUD::Compact = true;
if ($pref::EngHUD::MaxExtent $= "") $pref::EngHUD::MaxExtent = getWord(EngHUD.extent,1);
if ($pref::EngHUD::Width $= "") $pref::EngHUD::Width = getWord(EngHUD.extent,0);
if ($pref::EngHUD::PosX $= "") $pref::EngHUD::PosX = "0";
if ($pref::EngHUD::PosY $= "") $pref::EngHUD::PosY = "30";

activatePackage(EngineerHUD);
